﻿Public Class MainForm
    Implements IObserver

    Private _sensor As TemperatureSensor

    Public Sub New()
        Me.New(New TemperatureSensor())
    End Sub

    Public Sub New(ByVal sensor As TemperatureSensor)
        InitializeComponent()
        _sensor = sensor
        _sensor.AddListener(Me)
    End Sub

    ' There's some Form method named Update; I don't care about it in this demo
    ' so I'll just shadow it.  In real life, I might have to change the name of
    ' the method.
    Public Shadows Sub Update() Implements IObserver.Update
        lblInfo.Text = _sensor.Name
        lblTemperature.Text = _sensor.Data
    End Sub

    Private Sub MainForm_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Click
        Dim frm As New MainForm(_sensor)
        frm.Show()
    End Sub
End Class
