﻿Public Class MainForm

    Private _sensor As TemperatureSensor

    Public Sub New()
        Me.New(New TemperatureSensor())
    End Sub

    Public Sub New(ByVal sensor As TemperatureSensor)
        InitializeComponent()
        _sensor = sensor
        _sensor.AddCallback(AddressOf SensorUpdated)
    End Sub

    Private Sub SensorUpdated(ByVal newTemperature As Double)
        lblTemperature.Text = newTemperature
    End Sub

    Private Sub MainForm_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Click
        Dim frm As New MainForm(_sensor)
        frm.Show()
    End Sub
End Class
