﻿Public Class MainForm

    Private _sensor As TemperatureSensor

    Public Sub New()
        Me.New(New TemperatureSensor())
    End Sub

    Public Sub New(ByVal sensor As TemperatureSensor)
        InitializeComponent()
        _sensor = sensor
        AddHandler _sensor.Update, AddressOf SensorUpdated
    End Sub

    Private Sub SensorUpdated(ByVal sender As Object, ByVal e As UpdateEventArgs)
        lblTemperature.Text = e.Data
    End Sub

    Private Sub MainForm_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Click
        Dim frm As New MainForm(_sensor)
        frm.Show()
    End Sub
End Class
